import { RequestHandler } from 'msw';
import { SetupWorker } from 'msw/browser';

type InitializeOptions = Parameters<SetupWorker['start']>[0];
declare function initialize(options?: InitializeOptions, initialHandlers?: RequestHandler[]): SetupWorker;
declare function getWorker(): SetupWorker;

type MswParameters = {
    msw?: RequestHandler[] | {
        handlers: RequestHandler[] | Record<string, RequestHandler>;
    };
};
type Context = {
    parameters: MswParameters;
};
declare const mswDecorator: <Story extends (...args: any[]) => any>(storyFn: Story, context: Context) => any;

declare const mswLoader: (context: Context) => Promise<{}>;

export { type Context, type InitializeOptions, type MswParameters, getWorker, initialize, mswDecorator, mswLoader };
