import { RequestHandler } from 'msw';
import { SetupServer } from 'msw/node';

type InitializeOptions = Parameters<SetupServer['listen']>[0];
declare function initialize(options?: InitializeOptions, initialHandlers?: RequestHandler[]): SetupServer;
declare function getWorker(): SetupServer;

type MswParameters = {
    msw?: RequestHandler[] | {
        handlers: RequestHandler[] | Record<string, RequestHandler>;
    };
};
type Context = {
    parameters: MswParameters;
};
declare const mswDecorator: <Story extends (...args: any[]) => any>(storyFn: Story, context: Context) => any;

declare const mswLoader: (context: Context) => Promise<{}>;

export { type Context, type InitializeOptions, type MswParameters, getWorker, initialize, mswDecorator, mswLoader };
